<?php
/*
define("ri2imageworks_imageMagic_path", "/usr/local/bin/");

require_once("/home/www/nextTemplate2/core.inc.php3");
require_once("/home/www/nextTemplate2/class.mysql.php");
require_once("/home/www/nextTemplate2/ntPackages/imageWorks/classes/class.imageWorks_imageInfo.php");
require_once("/home/www/nextTemplate2/ntPackages/imageWorks/classes/class.imageWorks_imageWorks.php");
*/

require_once("class.imageWorks_imageWorks.php");

class imageWorks_imageWithCorners extends imageWorks_imageWorks {
	var $cornerImgPath = '';
	
	var $northEastPng = '';
	var $northWestPng = '';
	var $southEastPng = '';
	var $southWestPng = '';
	
	var $tempFiles = array();
	var $tempDir = "/tmp/";
	
	function imageWorks_imageWithCorners() {
		$this->tempDir = ini_get('upload_tmp_dir');	
	}
	
	/*function loadFromCache() {
	}
	
	function writeToCache() {
	}*/
	
	function cornerImg($cornerImgPath) {
		$this->cornerImgPath = $cornerImgPath;
	}
	
	function buildCornerImages() {
		$info = &new imageWorks_imageInfo($this->cornerImgPath);
		
		if ($info->width % 2 != 0) {
			trigger_error("width of " . $this->cornerImgPath . " is not even");
			return false;
		}
		
		if ($info->height % 2 != 0) {
			trigger_error("height of " . $this->cornerImgPath . " is not even");
			return false;
		}
		
		$width = $info->width / 2;
		$height = $info->height / 2;
		
		$this->northEastPng = tempnam($this->tempDir, "ne") . ".png";
		$this->northWestPng = tempnam($this->tempDir, "nw") . ".png";
		$this->southEastPng = tempnam($this->tempDir, "se") . ".png";
		$this->southWestPng = tempnam($this->tempDir, "sw") . ".png";
		
		
		$this->tempFiles[] = $this->northEastPng;
		$this->tempFiles[] = $this->northWestPng;
		$this->tempFiles[] = $this->southEastPng;
		$this->tempFiles[] = $this->southWestPng;
		
//		var_dump(ri2imageworks_imageMagic_path . "convert " . $this->cornerImgPath . " -crop " . $width . "x". $height . "+0+0 -geometry 5x5 " . $this->northEastPng);

		$wxh = $width . "x" . $height;

		system(ri2imageworks_imageMagic_path . "convert " . $this->cornerImgPath . " -crop " . $wxh . "+0+0 -geometry " . $wxh . " " . $this->northWestPng);
		system(ri2imageworks_imageMagic_path . "convert " . $this->cornerImgPath . " -crop " . $wxh . "+" . $width . "+0 -geometry " . $wxh . " " . $this->northEastPng);
		system(ri2imageworks_imageMagic_path . "convert " . $this->cornerImgPath . " -crop " . $wxh . "+0+" . $height . " -geometry " . $wxh . " " . $this->southWestPng);
		system(ri2imageworks_imageMagic_path . "convert " . $this->cornerImgPath . " -crop " . $wxh . "+" . $width . "+" . $height . " -geometry " . $wxh . " " . $this->southEastPng);
	}
	
	function applyCorners($srcImg) {
		$cornerImgs = array($this->northEastPng, $this->northWestPng, $this->southEastPng, $this->southWestPng);
		$gravity = array('NorthEast', 'NorthWest', 'SouthEast', 'SouthWest');
		
		$imgs = array($srcImg);
		$this->tempFiles[] = $srcImg;
		
		for($i = 0; $i < 4; $i++) {
			$path = tempnam($this->tempDir, "step" . ($i+1)) . ".png";
			$this->tempFiles[] = $path;
			$imgs[] = $path;
		}
		
		for($i = 0; $i < 4; $i++) {
			system(ri2imageworks_imageMagic_path . "composite -gravity " . $gravity[$i] . " " . $cornerImgs[$i] . " " . $imgs[$i] . " " . $imgs[$i+1]);
		}
		
		return $imgs[count($imgs) - 1];
	}
	
	function render() {
/*		$this->buildCornerImages();
		return $this->applyCorners();*/
		
		return parent::render();
	}
	
	function filterSettings() {
		return "corn" . $this->cornerImgPath;	
	}
	
	function generateFile() {
		$geometry = "";
		
		require_once("class.imageWorks_imageInfo.php");
		$info = &new imageWorks_imageInfo($this->srcPath);
		
		if (($this->maxWidth < $info->width) | ($this->maxHeight < $info->height)) {
			$geometry = "-geometry " . $this->maxWidth . "x" . $this->maxHeight;
		}
		
		$inBeetween = tempnam($this->tempDir, "step0") . ".png";
		
		$command = ri2imageworks_imageMagic_path . "convert " . $geometry . " -colorspace RGB -flatten -adjoin \"" . $this->srcPath . "\" png:" . $inBeetween;

		$x = `$command`;
		
		$this->buildCornerImages();
		$rendererPng = $this->applyCorners($inBeetween);
		
		$command = ri2imageworks_imageMagic_path . "convert -colorspace RGB -quality " . $this->quality . " -antialias -interlace none -flatten -adjoin \"" . $rendererPng . "\"  +profile \"*\" +comment jpeg:" . $this->destPath;
		
		$x = `$command`;
	}
	
}
/*
$image = &new imageWorks_imageWithCorners();

$image->srcFile("lake.jpg");
$image->maxHeight(130);
$image->maxWidth(130);
$image->cornerImg("corner.png");

echo $image->render();
*/

?>